; //=========================
; // Dragonfire (Atari 2600)
; // 1982 - Imagic
; // 2007 - Eiksoft
; // 
; // www.Eiksoft.com
; //=========================
If CommandLine$() = "w" Then tmpW2 = 176: tmpW = 3 Else tmpW = 1: tmpW2 = 240
AppTitle "Dragonfire (1982) (Imagic)"
If tmpW = 3 Then
	CallDLL "bin/seticon.dll", "SetIconLg"
	CallDLL "bin/retro.dll", "SetWinPosFull"
	HidePointer 
EndIf	
Graphics 320, tmpW2, 16, tmpW
SetBuffer BackBuffer()
SeedRnd MilliSecs()

Global pScore, levelF
AppTitle "Dragonfire (1982 Imagic) (2007 Eiksoft) (" + FindHighScore() + " plays)"

Global imgBack1 = LoadAnimImage("gfx/back1.png", 320, 176, 0, 9)
Global imgHero = LoadAnimImage("gfx/hero.png", 14, 15, 0, 12)
Global imgFire = LoadAnimImage("gfx/fire.png", 16, 5, 0, 2)
Global imgFire2 = LoadAnimImage("gfx/fire2.png", 16, 17, 0, 2)
Global imgCave = LoadAnimImage("gfx/cave.png", 16, 9, 0, 2)
Global imgLife = LoadImage("gfx/life.png")
Global imgLogo = LoadImage("gfx/logo.png")
Global imgFont = LoadAnimImage("gfx/font.png", 14, 8, 0, 10)
Global imgTreasure = LoadAnimImage("gfx/treasure.png", 16, 9, 0, 6)
Global imgTreasure2 = LoadAnimImage("gfx/treasure2.png", 16, 9, 0, 4)
Global imgDragon = LoadAnimImage("gfx/dragon.png", 64, 19, 0, 72)
Global imgFlash = LoadImage("gfx/flash.png")

MaskImage imgFont, 255, 0, 255

Global sfxFire = LoadSound("sfx/fire.wav")
Global sfxJump = LoadSound("sfx/jump.wav")
Global sfxWalk = LoadSound("sfx/walk.wav")
Global sfxGame = LoadSound("sfx/game.wav")
Global sfxDeath1 = LoadSound("sfx/death1.wav")
Global sfxDeath2 = LoadSound("sfx/death2.wav")
Global sfxTreasure = LoadSound("sfx/treasure.wav")

Type Obj
	Field X#, Y#, F, T, S#, ID
End Type

Global gameTime = CreateTimer(60), dieFlash
If tmpW = 1 Then Origin 0, 32

.Reset
FlushKeys
If dieFlash = True Then	

	tmpT = MilliSecs()
	tmpS = 0
	Repeat
		Select tmpS
			Case 0, 2, 4, 6, 8
			DrawImage imgFlash, 0, 0 
			
			Default
			DrawImage imgBack1, 0, 0, levelF
		End Select
		
		RenderScore
		
		If MilliSecs() >= tmpT + 100 Then
			tmpS = tmpS + 1
			tmpT = MilliSecs()
		EndIf
		
		WaitTimer GameTime
		Flip: Cls
	Until tmpS = 10
	
	dieFlash = False
EndIf
FlushKeys

Global pX# = 281, pY# = 86, pF = 0, pT = MilliSecs(), pD = 0, pDuck, pJ, pG#, pLife = 6, pSpeed# = 2.5
Global waterT = MilliSecs(), waterD = 0, waterF = 0, fireT = MilliSecs(), fireT2 = MilliSecs()
Global randFire1 = Rand(1000, 1500), randFire2 = Rand(750, 1250), lvl1 = 3500
Global bKeyDown, section = 1, inCave = 1, walkTime, bTitle = True, dragD = 1, dragS# = 1.5, dragX# = 6, dragF
Global sfxChan, fireLimit, pDie, tmpShot

;section = 2
If section = 2 Then pY = 116: pX = 270: CreateTreasure

Repeat

If Section = 1 Then ; Castle Wall

	If pDuck = False Then
		If pD = 0 Then tmpF = 0 Else tmpF = 3
	Else
		tmpF = 0
	EndIf
	
	If bTitle = False Then 
		DrawImage imgHero, Int(pX), Int(pY), pF + tmpF
	Else
		DrawImage imgLogo, 160 - (ImageWidth(imgLogo) / 2), 20
	EndIf
	
	If RenderObj() = True Then sfxChan = PlaySound(sfxGame): dieFlash = True: Goto Reset
	DrawImage imgBack1, 0, 0, levelF
	tmpX = 111
	For tmpL = 0 To pLife - 1
		DrawImage imgLife, tmpX, 170
		tmpX = tmpX + 16
	Next
	
	RenderWaves
	RenderScore 
	
	If bTitle = False Then
	
		bAnim = False
		If KeyDown(208) Or KeyDown(31) Then
			If pD = 0 Then pF = 6 Else pF = 7
			pDuck = True
		Else
			If pF > 5 Then pF = 0
			pDuck = False
		EndIf
		
		bKeyDown = False
		If pDuck = False Then	
			If KeyDown(203) Or KeyDown(30) Then
				If pX > 13 Then 
					pX = pX - 1.5: bAnim = True: pD = 0
					bKeyDown = 1
				Else ; Next Level
					section = 2: incave = 1
					pY = 116: pX = 270: pDuck = False: pJ = False
					dragX# = 6
					Delete Each obj
					CreateTreasure
					
				EndIf
			ElseIf KeyDown(205) Or KeyDown(32) Then
				If pX < 305 Then pX = pX + 1.5: bAnim = True: pD = 1
				bKeyDown = 2
			EndIf
		EndIf
		
		If (KeyDown(44) Or KeyDown(57)) And pJ = False And pDuck = False Then
			pG = 1
			pJ = True
			sfxChan = PlaySound(sfxJump)
		EndIf
		
		If pJ = True Then
			pY = pY - pG
			If pG > -1 Then pG = pG - .06 Else pY = 86: pJ = False
			If pDuck = False Then bAnim = True
		EndIf
		
		If bAnim = True Then
			If MilliSecs() >= walkTime + 275 Then
				If pJ = False Then sfxChan = PlaySound(sfxWalk)
				walkTime = MilliSecs()
			EndIf
			
			If MilliSecs() >= pT + 20 Then
				If pF < 2 Then pF = pF + 1 Else pF = 0
				pT = MilliSecs()
			EndIf
		Else
			If pF < 6 Then pF = 0
		EndIf
	Else
		If KeyHit(88) Then pLife = 13: PlaySound sfxTreasure ; Lucky 13
		
		If KeyHit(57) Then 
			Delete Each Obj
			randFire1 = Rand(1000, 1500) 
			randFire2 = Rand(750, 1250)
			FlushKeys
			bTitle = False
			fireT = MilliSecs()
			fireT2 = MilliSecs()
			pScore = 0: levelF = 0
		EndIf
	EndIf
	
	tmpF = True
	For o.Obj = Each Obj
		If o\ID = 1 And o\S = 3.8 Then tmpF = False: randFire1 = Rand(lvl1 - 1000, lvl1): Exit
	Next
	
	If tmpF = True And MilliSecs() >= fireT + randFire1 Then
		o.Obj = New Obj
		tmpY = 83: o\S = 3.8
		o\X = 5: o\Y = tmpY: o\ID = 1
		fireT = MilliSecs()
		If section = 1 Then sfxChan = PlaySound(sfxFire)
	EndIf
	
	tmpF = True
	For o.Obj = Each Obj
		If o\ID = 1 And o\S = 1.5 Then tmpF = False: randFire2 = Rand(lvl1 + 500, lvl1 + 1500): Exit
	Next
	
	If tmpF = True And MilliSecs() >= fireT2 + randFire2 Then
		o.Obj = New Obj
		tmpY = 94: o\S = 1.5
		o\X = 5: o\Y = tmpY: o\ID = 1
		fireT2 = MilliSecs()
		If section = 1 Then sfxChan = PlaySound(sfxFire)
	EndIf

	If section = 2 Then StopChannel sfxchan
	
Else ; Dragon

	If pD = 0 Or pDie = 1 Then tmpF = 0 Else tmpF = 3
	If inCave = False Then DrawImage imgHero, Int(pX), Int(pY), pF + tmpF
	DrawImage imgCave, 272, 122, inCave
	
	If DragD = 0 Then tmpF = levelF * 4 Else tmpF = 36 + (levelF * 4)
	DrawImage imgDragon, dragX, 134, dragF + tmpF
	
	If DragD = 0 Then dragX = dragX - dragS Else dragX = dragX + dragS
	If DragD = 1 And dragX >= 250 Then dragD = 0
	If DragD = 0 And dragX <= 6 Then dragD = 1
	
	tmpR = 30 - ((levelF + 1) * 3)
	If Rand(1, tmpR) = Int(tmpR / 2) Then
		If DragD = 1 And pX <= dragX - 100 Then dragD = 0
		If DragD = 0 And pX >= dragX + 100 Then dragD = 1	
	EndIf
	
	If MilliSecs() >= dragTime + 60 Then
		If dragF < 2 Then dragF = dragF + 1 Else dragF = 0
		dragTime = MilliSecs()
	EndIf
	
	tmpDelay = 500 - ((levelF + 1) * 45)
	If tmpDelay < 80 Then tmpDelay = 80
	
		If DragD = 0 Then
				If pX >= DragX - 48 And pX <= dragX + 48 Then 
					If MilliSecs() >= fireLimit + tmpDelay And inCave = False Then
						o.Obj = New Obj
						o\X = dragX: o\Y = 134: o\ID = 3
						fireLimit = MilliSecs()
						sfxChan = PlaySound(sfxFire)
					EndIf
					If inCave = False Then dragF = 3
				
			EndIf
		Else
			If pX >= DragX + 24 And pX <= dragX + 96 Then 
				If MilliSecs() >= fireLimit + tmpDelay And inCave = False Then
					o.Obj = New Obj
					o\X = dragX + 48: o\Y = 134: o\ID = 3
					fireLimit = MilliSecs()
					sfxChan = PlaySound(sfxFire)
				EndIf
				If inCave = False Then dragF = 3
			EndIf
		EndIf
	
	tmpCheck = True
	For o.Obj = Each Obj
		If o\ID = 2 Then tmpCheck = False: Exit
	Next
	
	If tmpCheck = True Then DrawImage imgCave, 24, 6, 0
	
	If RenderObj() = True Then sfxChan = PlaySound(sfxGame): dieFlash = True: Goto Reset
	DrawImageRect imgBack1, 0, 154, 0, 154, 320, 22, levelF
	
	tmpX = 111
	For tmpL = 0 To pLife - 1
		DrawImage imgLife, tmpX, 170
		tmpX = tmpX + 16
	Next
	
	RenderScore 

	bAnim = False
	bKeyDown = False
	
	If pDie = False Then
	
		If KeyDown(203) Or KeyDown(30) Then
			inCave = 0
			
			If pX > 6 Then 
				pX = pX - pSpeed: bAnim = True: pD = 0
				bKeyDown = 1
				
			Else ; Next Level
	
			EndIf
		ElseIf (KeyDown(205) Or KeyDown(32)) And inCave = 0 Then
			If pX < 300 Then pX = pX + pSpeed: bAnim = True: pD = 1
			bKeyDown = 2
		EndIf
		
		If inCave = 0 Then
			If KeyDown(208) = True Then
				If pY < 116 Then pY = pY + pSpeed / 2: bAnim = True
			ElseIf KeyDown(200) = True Then
				If pY > 6 Then pY = pY - pSpeed / 2: bAnim = True
			EndIf
		EndIf
		
		If bAnim = True Then
			If MilliSecs() >= walkTime + 275 Then
				If pJ = False Then sfxChan = PlaySound(sfxWalk)
				walkTime = MilliSecs()
			EndIf
				
			If MilliSecs() >= pT + 20 Then
				If pF < 2 Then pF = pF + 1 Else pF = 0
				pT = MilliSecs()
			EndIf
		Else
			If pF < 6 Then pF = 0
		EndIf
		
		If pY >= 108 And pY <= 130 And pX >= 270 And pX <= 280 Then inCave = 1
		If tmpCheck = True Then
			If pY >= 3 And pY <= 10 And pX >= 16 And pX <= 34 Then
					Delete Each obj
					If levelF < 8 Then 
						levelF = levelF + 1
						lvl1 = lvl1 - 250
					EndIf
					pX# = 281: pY# = 86: pJ = False: pDuck = False: pD = 0: pF = 0
		
					randFire1 = Rand(1000, 1500)
					randFire2 = Rand(750, 1250)			
					fireT = MilliSecs()
					fireT2 = MilliSecs()
	
					section = 1
					If levelF < 8 Then
						pSpeed = pSpeed + .2
						dragS = dragS + .4
					EndIf
			EndIf
		EndIf
	Else

		If pF < 8 Then 
			pF = 8 
		Else
			If MilliSecs() >= pT + 150 Then
				pF = pF + 1
				If pF >= 11 Then 
					pDie = False
					section = 2: incave = 1
					pY = 116: pX = 270: pDuck = False: pJ = False: pF = 0: pD = 0
									
					If pLife > 0 Then 
						pLife = pLife - 1 
					Else
						sfxChan = PlaySound(sfxGame) 
						Delete Each Obj
						SaveScore
						dieFlash = True
						Goto Reset
					EndIf
				EndIf
				pT = MilliSecs()
				FlushKeys
			EndIf
		EndIf
		
	EndIf
EndIf

WaitTimer gameTime
Flip: Cls
Until KeyHit(1)
Delete Each Obj
If bTitle = True Then End
FlushKeys: Goto Reset

Function RenderObj()

For o.Obj = Each Obj
	If o\ID = 1 Then
		If section = 1 Then
			DrawImage imgFire, Int(o\X), o\Y, o\F
			
			If MilliSecs() >= o\T + 80 Then
				If o\F = 0 Then o\F = 1 Else o\F = 0
				o\T = MilliSecs()
			EndIf
			
			If bTitle = False And ImagesCollide(imgFire, o\X, o\Y, o\F, imgHero, pX, pY, pF) And (pX < 296 And pX > 13) Then			
				If Rand(1, 2) = 1 Then 
					sfxChan = PlaySound(sfxDeath1)
				Else 
					sfxChan = PlaySound(sfxDeath2)
				EndIf
				If KillPlayer(1) = True Then Return True 
			Else
				If o\X < 300 Then o\X = o\X + o\S Else Delete o
			EndIf
		Else
			Delete o
		EndIf
		
	ElseIf o\ID = 2 Then
		If o\F >= 6 Then
			If o\F = 7 Then tmpF = 2 Else tmpF = 0
			DrawImage imgTreasure2, Int(o\X), o\Y, o\S + tmpF
		
			If MilliSecs() >= o\T + 50 Then
				If o\S = 0 Then o\S = 1 Else o\S = 0
				o\T = MilliSecs()
			EndIf
			
			If ImagesCollide(imgTreasure2, o\X, o\Y, o\S, imgHero, pX, pY, pF) Then			
				Select o\F
					Case 6: tmpS = 200
					Case 7: tmpS = 400
					
				End Select
				
				sfxChan = PlaySound(sfxTreasure)
				pScore = pScore + tmpS
				Delete o
			EndIf

		Else
		
			DrawImage imgTreasure, o\X, o\Y, o\F
		
			If ImagesCollide(imgTreasure, o\X, o\Y, o\F, imgHero, pX, pY, pF) Then			
				Select o\F
					Case 0, 5: tmpS = 60
					Case 2, 3, 4: tmpS = 10
					Case 1: tmpS = 200
					
				End Select
				
				sfXChan = PlaySound(sfxTreasure)
				pScore = pScore + tmpS
				Delete o
			EndIf
		EndIf
	
	ElseIf o\ID = 3 Then
		DrawImage imgFire2, o\X, Int(o\Y), o\F
			
		If MilliSecs() >= o\T + 80 Then
			If o\F = 0 Then o\F = 1 Else o\F = 0
			o\T = MilliSecs()
		EndIf
			
		If inCave = 0 And pDie = False And ImagesCollide(imgFire2, o\X, o\Y, o\F, imgHero, pX, pY, pF) Then			
			If Rand(1, 2) = 1 Then 
				sfxChan = PlaySound(sfxDeath1)
			Else 
				sfxChan = PlaySound(sfxDeath2)
			EndIf
			If KillPlayer(2) = True Then Return True
			Delete o
		Else
			If o\Y > -19 Then o\Y = o\Y - 2.5 Else Delete o
		EndIf	
	EndIf
	
Next

Return False
End Function

Function RenderWaves()

If waterF > -1 Then ; Waves
	Color 47, 90, 160
	Rect 40, 135 - waterF, 112, waterF
	Rect 168, 135 - waterF, 112, waterF
	
	If MilliSecs() >= waterT + 350 Then
		If waterD = 0 Then
			If waterF < 5 Then waterF = waterF + 1 Else waterD = 1
		Else
			If waterF > 0 Then waterF = waterF - 1 Else waterD = 0
		EndIf
		waterT = MilliSecs()
	EndIf
	
EndIf

End Function

Function KillPlayer(mode)
	
	If mode = 1 Then
		pF = 8: pT = MilliSecs(): tmpI = 0
		Repeat
			If pDuck = True Then tmpD = 0 Else tmpD = 2
			DrawImage imgHero, Int(pX), Int(pY) - tmpD, pF
			DrawImage imgBack1, 0, 0, levelF
			tmpX = 111
			For tmpL = 0 To pLife - 1
				DrawImage imgLife, tmpX, 170
				tmpX = tmpX + 16
			Next
			
			RenderScore
			RenderWaves			
				
			If MilliSecs() >= pT + 150 Then
				If pF < 11 Then pF = pF + 1 
				pT = MilliSecs()
			EndIf
					
			If pJ = True Then
				pY = pY - pG
				If pG > -1 Then pG = pG - .065 Else pY = 86: pJ = False				
				
				If bKeyDown = 1 Then pX = pX - 1.5 ElseIf bKeyDown = 2 Then pX = pX + 1.5
			EndIf
						
			WaitTimer GameTime
			Flip: Cls
		Until pF >= 11
				
		pX# = 281: pY# = 86: pJ = False: pDuck = False: pD = 0: pF = 0
		fireT = MilliSecs()
		fireT2 = MilliSecs()		
		randFire1 = Rand(1000, 1500)
		randFire2 = Rand(750, 1250)		
		Delete Each Obj		
	
		FlushKeys
		If pLife > 0 Then pLife = pLife - 1 Else SaveScore: Return True
		Return False
	
	Else
		pDie = True	
			
	EndIf				
End Function

Function RenderScore()

tmpX = 175: tmpY = 160
If pScore = 0 Then tmpStr$ = "00" Else tmpStr$ = Str(pScore)
If Len(tmpStr$) = 3 Then tmpX = tmpX - 16
If Len(tmpStr$) = 4 Then tmpX = tmpX - 32
If Len(tmpStr$) = 5 Then tmpX = tmpX - 48

For i = 1 To Len(tmpStr$)
	DrawImage imgFont, tmpX, tmpY, Asc(Mid$(tmpStr$, i, 1)) - 48
	tmpX = tmpX + 16
Next

End Function

Function SaveScore()
File = OpenFile("highscores.txt")
If File = 0 Then 
	WriteFile("highscores.txt") 
Else 
	SeekFile File, FileSize("highscores.txt") 
EndIf

WriteLine File, CurrentTime$() + " " + CurrentDate$() + " - Score: " + Str(pScore) 
CloseFile File

End Function

Function FindHighscore()
File = OpenFile("highscores.txt")
If File = 0 Then 
	Return 1
Else 
	tmpS = 0: tmpC2 = 0
	Repeat
		tmpStr$ = ReadLine(File)
		tmpIn = Instr(tmpStr$, "Score:", 1)
		If tmpIn > 0 Then
			tmpQ = Len(tmpStr$) - (tmpIn + 6)
			tmpC = Int(Right(tmpStr$, tmpQ))
			If tmpC > tmpS Then tmpS = tmpC
		EndIf
		tmpC2 = tmpC2 + 1
	Until Eof(File)
	pScore = tmpS
	Return tmpC2 - 1
EndIf

End Function

Function CreateTreasure()
Delete Each Obj

For i = 0 To 1
	o.Obj = New Obj
	o\X = Rand(6, 150): o\Y = Rand(6, 61): o\ID = 2
	If levelF = 4 Or levelF = 5 Then
		o\F = Rand(0, 6)
	ElseIf levelF >= 6 Then 
		o\F = Rand(0, 7)
	Else
		o\F = Rand(0, 5)
	EndIf
Next

For i = 0 To 1
	o.Obj = New Obj
	o\X = Rand(6, 150): o\Y = Rand(61, 122): o\ID = 2
	If levelF = 4 Or levelF = 5 Then
		o\F = Rand(0, 6)
	ElseIf levelF >= 6 Then 
		o\F = Rand(0, 7)
	Else
		o\F = Rand(0, 5)
	EndIf
Next

For i = 0 To 1
	o.Obj = New Obj
	o\X = Rand(150, 300): o\Y = Rand(6, 61): o\ID = 2
	If levelF = 4 Or levelF = 5 Then
		o\F = Rand(0, 6)
	ElseIf levelF >= 6 Then 
		o\F = Rand(0, 7)
	Else
		o\F = Rand(0, 5)
	EndIf
Next

For i = 0 To 1
	o.Obj = New Obj
	o\X = Rand(150, 300): o\Y = Rand(61, 122): o\ID = 2
	If levelF = 4 Or levelF = 5 Then
		o\F = Rand(0, 6)
	ElseIf levelF >= 6 Then 
		o\F = Rand(0, 7)
	Else
		o\F = Rand(0, 5)
	EndIf
Next

End Function